

	
TACHYON
{
										ROTARY ENCODER
										
		UPDATED 20121224.1600 - BBR isolated FOR POSTING					
		CREATED 20121124.1800 - BB Riley, Underhill Center, VT  
		                        brianbr@wulfden.org

		TESTED  Tachyon Forth V21 121114.1330 Extend 121113.1200
}
		
: rotaryencoder.fth	." Rotary Encoder Tool kit - 121128.1300"  ;


#P16	CONSTANT	#selectsw	\  SELECT switch
#P26	CONSTANT	#enc.a		\  A output from encoder
#P27	CONSTANT	#enc.b		\  B output from encoder

LONG	oldBits,newBits,maxdata

LONG	varptr		\  variable to be used as indirect pointer, passing
					\  variable addresses to QDEC@
					\  to assign variable to indirect			"newvar varptr !"
					\  to reference the address of "newvar" you "varptr @"
					\  to access the value of "newvar" you		"varptr @ @"
					
\  ------------- Supporting words --------------------

: QE@	( -- ) IN@ #enc.a SHR 3 AND ;	\ get current state	

: SELECTED?		( -- true/false )
		#selectsw PIN@ 		IF	FALSE			ELSE
		2 ms #selectsw PIN@ IF	FALSE 			ELSE 
								TRUE 	THEN	THEN
		150 ms					\  part of debouncing
		;		

\  ------------- Quadrature Encoder --------------------

: QDEC@	( dataddr datamax -- )	\ QuadratureDecoder
	maxdata !					\  write max allowed value
	varptr !					\  write var address to pointer
	#enc.a PININP				\  Set encoder pins to inputs
	#enc.b PININP
	QE@  oldBits !				\  Pre-initialize oldBits (prevents 
								\       non-zero starting count)
	BEGIN
    	QE@	DUP newBits !		\  read encoder
		oldBits @
		<> IF					\  compare oldBits to newBits. Has it changed? 
		 		\ counter = counter - 1 + (2 * (newBits.BIT0 ^ oldBits.BIT1))
	     		\ the next 4 lines are the TF implementation of the above PBASIC
			newBits @ 1 AND		\  determine direction and add or subtract from counter
			oldBits @ 2/
			XOR 2* 1-
			varptr @ @ +		\  add to old var 
			0 MAX				\  apply min/max - 0 minimum
			maxdata @ MIN		\  cap the top
			varptr @ !			\  write new val to var
			newBits @ oldBits !  \ Update oldBits
			." ?x09?y0" varptr @ @ $030A .NUM
		THEN

	SELECTED? UNTIL				
	DROP
	;

\  ----------------------------------------

{

#120	CONSTANT	#maxdur		\  max value for duration
#15		CONSTANT	#maxon		\  max value for on period
#10		CONSTANT	#maxoff		\  max value for off period

LONG	duration,onperiod,offperiod,runningtime,totaltime



:  EDITPARMS	( -- )
	LCDLIN0 .duration
	duration #maxdur QDEC@	
\ ---------------------------
	LCDLIN0 .onperiod
	onperiod #maxon QDEC@
\ ---------------------------
	LCDLIN0 .offperiod
	offperiod #maxoff QDEC@
	;
}

END
                  


	